//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3779213AF37B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3779213AF37B.cm

//## begin module%3779213AF37B.cp preserve=no
//## end module%3779213AF37B.cp

//## Module: Reference%3779213AF37B; Package specification
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Source file: /data/verisB/dorman/Xspec/src/XSUtil/Utils/Reference.h

#ifndef REFERENCE_H
#define REFERENCE_H 1

//## begin module%3779213AF37B.additionalIncludes preserve=no
//## end module%3779213AF37B.additionalIncludes

//## begin module%3779213AF37B.includes preserve=yes
//## end module%3779213AF37B.includes

//## begin module%3779213AF37B.declarations preserve=no
//## end module%3779213AF37B.declarations

//## begin module%3779213AF37B.additionalDeclarations preserve=yes
//## end module%3779213AF37B.additionalDeclarations


//## begin RefCounter%3777E2382608.preface preserve=yes
//## end RefCounter%3777E2382608.preface

//## Class: RefCounter%3777E2382608
//	Mixin class for reference counted objects.
//
//	C++ Utilities for xspec.
//	Created to add Scott Meyer's reference counting
//	machinery to component classes. This is felt needed to
//	deal with the implementation of component groups. The
//	calculated part of ComponentGroup (the result of
//	evaluating a set of components which are to be combined)
//	is a SumComponent which is a subclass of AddComponent.
//	This is contained by value in some ComponentGroup and is
//	pointed to by a pointer in the list of components in a
//	different component group.
//
//
//	Since the processes of manipulation require copying
//	this, component and assigning it to new temporary
//	copies, care must be taken that the by-value object is
//	never "deep copied" or destructed, unlike other
//	temporaries created in manipulating the list.
//	Implementing reference counts appears to be the most
//	efficient way of dealing with this type of problem/usage.
//	Reference counted classes hold a single copy of the data
//	and reproduce another copy if it is needed to change it.
//	Identical copies are produced by simply adding a pointer.
//	6/28/99, revised 8/16/2000
//## Category: XSUtil::Utils%370B67146E50
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class RefCounter 
{
  //## begin RefCounter%3777E2382608.initialDeclarations preserve=yes
  //## end RefCounter%3777E2382608.initialDeclarations

  public:
    //## Constructors (generated)
      RefCounter();

    //## Destructor (generated)
      virtual ~RefCounter();


    //## Other Operations (specified)
      //## Operation: addReference%3779210DCD21;  C++
      void addReference ();

      //## Operation: removeReference%3779210DCD22;  C++
      void removeReference ();

      //## Operation: markUnshareable%3779210DCD23;  C++
      void markUnshareable ();

      //## Operation: isShared%3779210DCD24;  C++
      bool isShared ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: refCount%3779210D97B8
      int refCount () const;

      //## Attribute: shareable%3779210DCD20
      bool shareable () const;
      void shareable (bool value);

    // Additional Public Declarations
      //## begin RefCounter%3777E2382608.public preserve=yes
      //## end RefCounter%3777E2382608.public

  protected:
    //## Constructors (specified)
      //## Operation: RefCounter%3779210DCD25;  C++
      RefCounter (const RefCounter& );


    //## Other Operations (specified)
      //## Operation: operator=%3779210DCD27;  C++
      RefCounter& operator = (const RefCounter& );

    // Additional Protected Declarations
      //## begin RefCounter%3777E2382608.protected preserve=yes
      //## end RefCounter%3777E2382608.protected

  private:
    // Additional Private Declarations
      //## begin RefCounter%3777E2382608.private preserve=yes
      //## end RefCounter%3777E2382608.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin RefCounter::refCount%3779210D97B8.attr preserve=no  public: int {U} 0
      int m_refCount;
      //## end RefCounter::refCount%3779210D97B8.attr

      //## begin RefCounter::shareable%3779210DCD20.attr preserve=no  public: bool {U} true
      bool m_shareable;
      //## end RefCounter::shareable%3779210DCD20.attr

    // Additional Implementation Declarations
      //## begin RefCounter%3777E2382608.implementation preserve=yes
      //## end RefCounter%3777E2382608.implementation

};

//## begin RefCounter%3777E2382608.postscript preserve=yes
//## end RefCounter%3777E2382608.postscript

//## begin RefCountPtr%3778CF459778.preface preserve=yes
//## end RefCountPtr%3778CF459778.preface

//## Association: <unnamed>%3779213ADE39
//## Category: <Top Level>; Global

//## Class: RefCountPtr%3778CF459778; Parameterized Class
//## Category: XSUtil::Utils%370B67146E50
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Persistence: Transient
//## Cardinality/Multiplicity: n



template <class T>
class RefCountPtr 
{
  //## begin RefCountPtr%3778CF459778.initialDeclarations preserve=yes
  //## end RefCountPtr%3778CF459778.initialDeclarations

  public:
    //## Constructors (generated)
      RefCountPtr(const RefCountPtr< T > &right);

    //## Constructors (specified)
      //## Operation: RefCountPtr%3778D0392A98; C++
      RefCountPtr (T* real = 0);

    //## Destructor (generated)
      ~RefCountPtr();

    //## Assignment Operation (generated)
      RefCountPtr< T > & operator=(const RefCountPtr< T > &right);

    //## Indirection Operation (generated)
      T* operator->() const;

    //## Dereference Operation (generated)
      T& operator*() const;

    // Additional Public Declarations
      //## begin RefCountPtr%3778CF459778.public preserve=yes
      //## end RefCountPtr%3778CF459778.public

  protected:
    // Additional Protected Declarations
      //## begin RefCountPtr%3778CF459778.protected preserve=yes
      //## end RefCountPtr%3778CF459778.protected

  private:

    //## Other Operations (specified)
      //## Operation: init%3778D009D8F0; C++
      void init ();

    // Additional Private Declarations
      //## begin RefCountPtr%3778CF459778.private preserve=yes
      //## end RefCountPtr%3778CF459778.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: pointed%3778CFDB9218
      //## begin RefCountPtr::pointed%3778CFDB9218.attr preserve=no  private: T* {U} 
      T* m_pointed;
      //## end RefCountPtr::pointed%3778CFDB9218.attr

    // Data Members for Associate Classes



    // Additional Implementation Declarations
      //## begin RefCountPtr%3778CF459778.implementation preserve=yes
      //## end RefCountPtr%3778CF459778.implementation

};

//## begin RefCountPtr%3778CF459778.postscript preserve=yes
//## end RefCountPtr%3778CF459778.postscript

// Class RefCounter 

//## Get and Set Operations for Class Attributes (inline)

inline int RefCounter::refCount () const
{
  //## begin RefCounter::refCount%3779210D97B8.get preserve=no
  return m_refCount;
  //## end RefCounter::refCount%3779210D97B8.get
}

inline bool RefCounter::shareable () const
{
  //## begin RefCounter::shareable%3779210DCD20.get preserve=no
  return m_shareable;
  //## end RefCounter::shareable%3779210DCD20.get
}

inline void RefCounter::shareable (bool value)
{
  //## begin RefCounter::shareable%3779210DCD20.set preserve=no
  m_shareable = value;
  //## end RefCounter::shareable%3779210DCD20.set
}

// Parameterized Class RefCountPtr 

template <class T>
inline T* RefCountPtr<T>::operator->() const
{
  //## begin RefCountPtr::operator->%3778CF459778_ptr.body preserve=yes
  return m_pointed;
  //## end RefCountPtr::operator->%3778CF459778_ptr.body
}


template <class T>
inline T& RefCountPtr<T>::operator*() const
{
  //## begin RefCountPtr::operator*%3778CF459778_deref.body preserve=yes
  return *m_pointed;
  //## end RefCountPtr::operator*%3778CF459778_deref.body
}


// Parameterized Class RefCountPtr 

template <class T>
RefCountPtr<T>::RefCountPtr(const RefCountPtr<T> &right)
  //## begin RefCountPtr::RefCountPtr%3778CF459778_copy.hasinit preserve=yes
  : m_pointed(right.m_pointed)
  //## end RefCountPtr::RefCountPtr%3778CF459778_copy.hasinit
  //## begin RefCountPtr::RefCountPtr%3778CF459778_copy.initialization preserve=yes
  //## end RefCountPtr::RefCountPtr%3778CF459778_copy.initialization
{
  //## begin RefCountPtr::RefCountPtr%3778CF459778_copy.body preserve=yes
  init();
  //## end RefCountPtr::RefCountPtr%3778CF459778_copy.body
}

template <class T>
RefCountPtr<T>::RefCountPtr (T* real)
  //## begin RefCountPtr::RefCountPtr%3778D0392A98.hasinit preserve=yes
  : m_pointed(real)
  //## end RefCountPtr::RefCountPtr%3778D0392A98.hasinit
  //## begin RefCountPtr::RefCountPtr%3778D0392A98.initialization preserve=yes
  //## end RefCountPtr::RefCountPtr%3778D0392A98.initialization
{
  //## begin RefCountPtr::RefCountPtr%3778D0392A98.body preserve=yes
  init();
  //## end RefCountPtr::RefCountPtr%3778D0392A98.body
}


template <class T>
RefCountPtr<T>::~RefCountPtr()
{
  //## begin RefCountPtr::~RefCountPtr%3778CF459778_dest.body preserve=yes
  if (m_pointed) m_pointed->removeReference();
  //## end RefCountPtr::~RefCountPtr%3778CF459778_dest.body
}


template <class T>
RefCountPtr<T> & RefCountPtr<T>::operator=(const RefCountPtr<T> &right)
{
  //## begin RefCountPtr::operator=%3778CF459778_assign.body preserve=yes
  if (m_pointed != right.m_pointed)
  {
        if (m_pointed) m_pointed->removeReference();
        
        m_pointed = right.m_pointed;
        
        init();
        
  }
  
  return *this;
  //## end RefCountPtr::operator=%3778CF459778_assign.body
}



//## Other Operations (implementation)
template <class T>
void RefCountPtr<T>::init ()
{
  //## begin RefCountPtr::init%3778D009D8F0.body preserve=yes
  if ( m_pointed == 0 ) return;
  
  // T must:
  // a) inherit from RefCount (so that isShareable and addReference exist)
  // b) have a deep copy constructor
  // c) Must have a virtual copy constructor if there are derived classes.
  
  if ( !m_pointed->shareable() )
  {
        m_pointed = m_pointed->clone();
  }
  
  m_pointed->addReference();
  //## end RefCountPtr::init%3778D009D8F0.body
}

// Additional Declarations
  //## begin RefCountPtr%3778CF459778.declarations preserve=yes
  //## end RefCountPtr%3778CF459778.declarations

//## begin module%3779213AF37B.epilog preserve=yes
//## end module%3779213AF37B.epilog


#endif
